#include <AD9850.h>

#define encoder0PinA 2
#define encoder0PinB 3

volatile unsigned int encoder0Pos = 10;
unsigned long krok = 1;
long x[] = {1, 10, 100, 1000, 10000, 100000, 1000000};
byte a = 0;

const int W_CLK_PIN = 7;
const int FQ_UD_PIN = 8;
const int DATA_PIN = 9;
const int RESET_PIN = 10;


double freq = 1000000;
double trimFreq = 124999500;

int phase = 0;


void setup() {

  pinMode(encoder0PinA, INPUT); 
  pinMode(encoder0PinB, INPUT); 
  pinMode(4,INPUT);
  pinMode(13,OUTPUT);

  attachInterrupt(0, doEncoderA, FALLING);
  attachInterrupt(1, doEncoderB, FALLING);  


  Serial.begin (9600);
  
  DDS.begin(W_CLK_PIN, FQ_UD_PIN, DATA_PIN, RESET_PIN);
  DDS.calibrate(trimFreq);
  DDS.setfreq(freq, phase);

}




void loop()
{
if (digitalRead(4) == LOW) 

           { 
              digitalWrite(13, HIGH);
              delay(100);
              digitalWrite(13, LOW);
              delay(100);
              digitalWrite(13, HIGH);
              delay(100);
              digitalWrite(13, LOW);
              delay(100);
              digitalWrite(13, HIGH);
              delay(100);
              digitalWrite(13, LOW);
              a++;
              if (a == 7) {a=0;}
              
              delay(20);  
              krok = x[a];
           }

                        
}//end
//syntezaDDS();






  
 //detachInterrupt(0);    //Wyłącz przerwanie 0 EncoderA
 //detachInterrupt(1);    //Wyłącz przerwanie 1 EncoderB

 
 
 // attachInterrupt(0, doEncoderA, FALLING); //włącz P0 EncoderA
 // attachInterrupt(0, doEncoderB, FALLING); //włącz P1 EncoderB
  
// koniec void loop***************************



//----------------- Programy wykonawacze DDS plus nimus -----------------
 
void syntezaDDSplus()
{
freq = freq + krok;
DDS.setfreq(freq, phase);

Serial.println (freq, DEC);        

}

 
void syntezaDDSminus()
{
freq = freq - krok;
DDS.setfreq(freq, phase);

Serial.println (freq, DEC);        


}

 
void syntezaDDS()
{

}








//*************************************  PRZERWANIE A  *********************
void doEncoderA(){
  delay(10);
  if (digitalRead(encoder0PinA) == LOW) 
      { 
    
           if (digitalRead(encoder0PinB) == HIGH) 
            {  
             encoder0Pos = encoder0Pos - 1;         // CW
            syntezaDDSminus();
            
            } 
             
      }

     
  //Serial.print (krok, DEC);
  //Serial.print ("  ");  
  //Serial.println (freq, DEC);        


}

//********************************  PRZERWANIE B  ************************



void doEncoderB()
{
delay(10);
  
     if (digitalRead(encoder0PinB) == LOW) 
      {   

        if (digitalRead(encoder0PinA) == HIGH) 
        {  
          encoder0Pos = encoder0Pos + 1;         // CW
        syntezaDDSplus();
        } 
        
      }
   


}
//************************** KONIEC PRZERWAŃ **************************** 




 

